################################################################################################
#
# Swimming House
#
################################################################################################




scoreboard players set @e ET3 1
scoreboard players set @e[type=item] ET3 0
scoreboard players set @e[type=armor_stand] ET3 0
scoreboard players set @e[type=end_crystal] ET3 0
scoreboard players set @e[type=area_effect_cloud] ET3 0
scoreboard players set @e[type=boat] ET3 0
scoreboard players set @e[type=arrow] ET3 0
scoreboard players set @e[type=painting] ET3 0
scoreboard players set @e[type=player] ET3 0
scoreboard players set @e[type=arrow] ET3 0
scoreboard players set @e[type=minecart] ET3 0
scoreboard players set @e[type=experience_orb] ET3 0
scoreboard players set @e[type=zombie] ET3 2
scoreboard players set @e[type=zombie_villager] ET3 2
scoreboard players set @e[type=zombie_horse] ET3 2
scoreboard players set @e[type=zombie_pigman] ET3 2
scoreboard players set @e[type=wither_skeleton] ET3 2
scoreboard players set @e[type=husk] ET3 2
scoreboard players set @e[type=skeleton] ET3 2
scoreboard players set @e[type=stray] ET3 2
scoreboard players set @e[tag=swim_pig] ET3 0


################################################################# General ################################################################

execute as @a[tag=!init_msg3] at @s run function swimming_house:init
effect give @e[tag=invis] minecraft:invisibility 1 1 true





################################################### Spawn/Despawn & Give #############################################

give @a[tag=give3] minecraft:rabbit_spawn_egg{display:{Name:"{\"text\":\"§6§lSwimming House\"}",Lore:["Rightclick to spawn."]},EntityTag:{id:"minecraft:armor_stand",Invisible:1,Marker:1,Tags:["sp_swim"]},HideFlags:63}
tag @a[tag=give3] remove give3
execute as @e[tag=sp_swim] at @s run function swimming_house:spawn_house

execute as @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:1b},OnGround:1b}] at @s positioned ~ ~-1 ~ run execute as @e[tag=swimming_house_center,distance=..2] at @s run function swimming_house:despawn_house


execute as @e[type=item,nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b}] at @s if block ~ ~-0.5 ~ chest{Items:[{Slot:3b,id:"minecraft:brick_stairs",Count:10b},{Slot:4b,id:"minecraft:brick_stairs",Count:10b},{Slot:5b,id:"minecraft:brick_stairs",Count:10b},{Slot:12b,id:"minecraft:oak_log",Count:4b},{Slot:13b,id:"minecraft:jungle_planks",Count:64b},{Slot:14b,id:"minecraft:oak_log",Count:4b},{Slot:21b,id:"minecraft:stone_bricks",Count:5b},{Slot:22b,id:"minecraft:stone_bricks",Count:5b},{Slot:23b,id:"minecraft:stone_bricks",Count:5b}]} run summon area_effect_cloud ~ ~ ~ {Tags:[shs_aec]}

execute as @e[tag=shs_aec] at @s run setblock ~ ~-0.5 ~ air
execute as @e[tag=shs_aec] at @s run kill @e[type=item,nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b},distance=..2]
execute as @e[tag=shs_aec] at @s run summon armor_stand ~ ~-1 ~ {Tags:[sp_swim],Invisible:1,Maker:1}



##########################################################  Animation Controller ######################################################

scoreboard players add @e[tag=swimming_house_center] swim_house_state 0
scoreboard players add @e[tag=swimming_house_center] sw_trans_timer 0
scoreboard players add @e[tag=swimming_house_center] sw_trans_timer2 0

tag @a remove swim_rider
tag @a[nbt={RootVehicle:{Entity:{id:"minecraft:armor_stand",Tags:["swim_ride"]}}}] add swim_rider
execute as @a[tag=swim_rider] at @s run scoreboard players set @e[tag=swimming_house_center,scores={sw_trans_timer=0,sw_trans_timer2=0,swim_house_state=0}] sw_trans_timer 1


scoreboard players add @a swim_was_rider 0
scoreboard players remove @a[scores={swim_was_rider=1..}] swim_was_rider 1
scoreboard players set @a[tag=swim_rider] swim_was_rider 100

scoreboard players add @e[tag=swimming_house_center,scores={sw_trans_timer2=0,sw_trans_timer=0,swim_house_state=1}] swim_rider_exit 1
execute as @a[tag=swim_rider] at @s run scoreboard players set @e[tag=swimming_house_center] swim_rider_exit 0

scoreboard players set @e[tag=swimming_house_center,scores={swim_rider_exit=3..,sw_trans_timer2=0,sw_trans_timer=0,swim_house_state=1}] sw_trans_timer2 1


execute as @e[tag=swimming_house_center,scores={sw_trans_timer=1..}] at @s run function swimming_house:animate_in
execute as @e[tag=swimming_house_center,scores={sw_trans_timer2=1..}] at @s run function swimming_house:animate_out

########################################################## General ######################################################

execute as @e[tag=swimming_house_center] at @s run function swimming_house:house_exists

scoreboard players add @e[tag=swimming_house_center] swim_active 0
scoreboard players add @e[tag=swimming_house_center,scores={sw_trans_timer=1..100}] swim_active 1
execute as @e[tag=swimming_house_center,scores={swim_active=1..}] at @s run function swimming_house:house_active




############################################################## Bombs ##################################################


execute as @e[tag=swim_bomb_body,tag=!chain_spawned] at @s run summon armor_stand ~ ~-2 ~ {NoGravity:1,Tags:[chain_spawner],Invisible:1,Marker:1,DisabledSlots:4144959}
tag @e[tag=swim_bomb_body] add chain_spawned

execute as @e[tag=chain_spawner] at @s run summon armor_stand ~ ~ ~ {Tags:[bomb_chain],NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:44}}],Invisible:1,DisabledSlots:4144959}
execute as @e[tag=chain_spawner] at @s unless block ~ ~-3 ~ #swimming_house:water_passable run tag @s add kill_chain_spawner
execute as @e[tag=chain_spawner] at @s run tp @s ~ ~-3 ~
execute as @e[tag=kill_chain_spawner] at @s run summon armor_stand ~ ~ ~ {Tags:[bomb_chain],NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:44}}],Invisible:1,DisabledSlots:4144959}
kill @e[tag=kill_chain_spawner]

execute as @e[tag=swim_bomb_body] at @s positioned ~-0.5 ~1 ~-0.5 run execute at @e[scores={ET3=1..2},dx=0.25,dy=-100,dz=0.25] run tag @s add bomb_explode
execute as @e[tag=swim_bomb_body] at @s positioned ~-0.5 ~1 ~-0.5 run execute at @a[dx=0.25,dy=-100,dz=0.25] run tag @s add bomb_explode

execute as @e[tag=bomb_explode] at @s positioned ~-0.5 ~2 ~-0.5 run kill @e[tag=bomb_chain,dx=0.25,dy=-100,dz=0.25]
execute as @e[tag=bomb_explode] at @s run particle large_smoke ~ ~ ~ 2 2 2 0.1 100 force
execute as @e[tag=bomb_explode] at @s run particle cloud ~ ~ ~ 0 0 0 0.8 50 force
execute as @e[tag=bomb_explode] at @s run particle explosion ~ ~ ~ 1 1 1 0.2 10 force
execute as @e[tag=bomb_explode] at @s run kill @e[scores={ET3=1..2},distance=..20]
execute as @e[tag=bomb_explode] at @s run playsound minecraft:entity.generic.explode master @a
execute as @e[tag=bomb_explode] at @s run kill @e[tag=bomb_explode]




############################################################## Missile ##################################################

scoreboard players add @e[tag=swim_missile] swim_m_lt 1
execute as @e[scores={swim_m_lt=1}] at @s run tp @s @e[tag=swimming_house_center,limit=1,sort=nearest]
execute as @e[scores={swim_m_lt=1}] at @s run tp @s ~ ~ ~ ~ 0

execute as @e[scores={swim_m_lt=2..}] at @s run tp @s ^ ^ ^-0.8
execute as @e[scores={swim_m_lt=2..199}] at @s unless block ^ ^ ^ #swimming_house:water_passable run scoreboard players set @s swim_m_lt 200
execute as @e[scores={swim_m_lt=2..}] at @s run particle flame ~ ~ ~ 0 0 0 0.01 1 force
execute as @e[scores={swim_m_lt=2..}] at @s run particle smoke ~ ~ ~ 0 0 0 0.1 1 force
execute as @e[scores={swim_m_lt=2..}] at @s run particle cloud ~ ~ ~ 0 0 0 0.01 2 force

execute as @e[scores={swim_m_lt=200}] at @s run playsound minecraft:entity.generic.explode master @a
execute as @e[scores={swim_m_lt=200}] at @s run particle explosion ~ ~ ~ 1 1 1 0.2 10 force
execute as @e[scores={swim_m_lt=200}] at @s run summon minecraft:creeper ~ ~ ~ {ExplosionRadius:10b,Fuse:0,ignited:1b}
execute as @e[scores={swim_m_lt=201}] at @s run function swimming_house:missile_exp_fill

kill @e[tag=swim_mis_exp]
kill @e[scores={swim_m_lt=198}]
kill @e[scores={swim_m_lt=201..}]

############################################################## Water Vortex ##################################################

scoreboard players add @e[tag=swim_tornado] tornado_lt 1
execute as @e[scores={tornado_lt=3..}] at @s run execute as @e[scores={tornado_lt=..2},distance=..16] at @s run title @a[tag=swim_rider] actionbar ["",{"text":"2 Vortexes must be more than 15 blocks apart!","color":"dark_red"}]

execute as @e[scores={tornado_lt=3..}] at @s run kill @e[scores={tornado_lt=..2},distance=..16]

execute as @e[scores={tornado_lt=2}] at @s run summon armor_stand ~ ~ ~ {Tags:["tornado_spin1","tornado_spin"],NoGravity:1,Invisible:1,Marker:1}
execute as @e[scores={tornado_lt=2}] at @s run summon armor_stand ~ ~ ~ {Tags:["tornado_spin2","tornado_spin"],NoGravity:1,Invisible:1,Marker:1}

execute as @e[tag=tornado_spin1] at @s run tp @s ~ ~ ~ ~12 ~
execute as @e[tag=tornado_spin2] at @s run tp @s ~ ~ ~ ~15 ~

execute as @e[tag=swim_tornado] at @s run particle bubble ^ ^ ^ 1 1 1 0.05 10 force
execute as @e[tag=tornado_spin1] at @s run particle cloud ^ ^-1 ^2 0 0 0 0.05 1 force
execute as @e[tag=tornado_spin2] at @s run particle cloud ^3.5 ^1 ^ 0 0 0 0.04 1 force

execute as @e[scores={tornado_lt=5..}] at @s run tp @e[scores={ET3=1..2},distance=2..15] @s

tag @e[scores={ET3=1..3}] remove in_vortex
execute as @e[scores={tornado_lt=5..}] at @s run tag @e[scores={ET3=1..3},distance=..2] add in_vortex
scoreboard players set @e[scores={ET3=1..2},tag=!in_vortex] vortex_effect 0
scoreboard players add @e[scores={ET3=1..2},tag=in_vortex] vortex_effect 1

execute as @e[scores={tornado_lt=5..}] at @s run execute as @e[scores={ET3=1..2,vortex_effect=..5},distance=..2.1] at @s run tp @s ~ ~0.03 ~

execute as @e[scores={tornado_lt=6000..}] at @s run kill @e[tag=tornado_spin1,limit=1,sort=nearest]
execute as @e[scores={tornado_lt=6000..}] at @s run kill @e[tag=tornado_spin2,limit=1,sort=nearest]
execute as @e[scores={tornado_lt=6000..}] at @s run kill @s



scoreboard players set @a rc3 0
